import { StyleType } from './style.model';
import { PageNodeAttribute } from './page-node.model';
export type PageNodeSchema = PageElementNodeSchema | PageTextNodeSchema | PageCustomNodeSchema;
export interface PageElementNodeSchema extends PageBaseNodeSchema {
    styles?: {
        [key in StyleType]?: Record<string, string>;
    };
    cssClasses?: string[];
    children?: PageNodeSchema[];
}
export interface PageTextNodeSchema extends PageBaseNodeSchema {
}
export interface PageCustomNodeSchema extends PageBaseNodeSchema {
}
export interface PageBaseNodeSchema {
    key?: string;
    tag: string;
    attributes: PageNodeAttribute[];
}
