export interface EventListener<T = any> {
    handler(payload: T): void;
    once?: boolean;
    autoUnlistenWhen?: () => boolean;
}
export interface IEventEmitter {
    on<T>(eventNames: string, handler: EventListener<T>['handler'], options?: Pick<EventListener<T>, 'autoUnlistenWhen'>): () => void;
    once<T>(eventName: string, handler: EventListener<T>['handler']): () => void;
    emit<T>(eventName: string, payload?: T): void;
}
