import { PageOptions } from "./page-options.model";
import { IEventEmitter } from "./event-emitter.model";
import { IPageElementNode, PageNode } from "./page-node.model";
import { PageNodeSchema } from "../models/element-schema.model";
export interface IPageLibrary {
    name: string;
    href: string;
    rel: string;
    [prop: string]: any;
}
export interface IPage extends IEventEmitter {
    windowRef: Window;
    documentRef: Document;
    getSchema(): PageNodeSchema;
    findElement(predicate: (el: PageNode) => boolean): PageNode | undefined;
    getRootElement(): IPageElementNode;
    getLinkedLibraries(): IPageLibrary[];
    getOptions(): PageOptions;
    buildElements(container: HTMLElement): void;
    linkLibrary(library: IPageLibrary): Promise<void>;
}
