import { Page } from "../page";
import { IPageBaseNode, NodeType } from "../models/page-node.model";
import { EventEmitter } from "../event-emitter";
import { ElementAttributes } from "../element-attributes";
import { IPageElementNode } from "../models/page-node.model";
import { PageNodeSchema } from "../models/element-schema.model";
export declare abstract class PageBaseNode<T extends PageBaseNode<T>> extends EventEmitter implements IPageBaseNode {
    key: string;
    children?: IPageBaseNode[];
    attributes: ElementAttributes;
    abstract nodeType: NodeType;
    abstract nativeElement: Node | Element;
    abstract schema: PageNodeSchema;
    abstract page: Page;
    abstract parentElement?: IPageElementNode | undefined;
    abstract get hostElement(): Node | Element;
    constructor();
    createNode(): void;
    findElement(predicate: (el: IPageBaseNode) => boolean): IPageBaseNode | undefined;
    destroy(): void;
    getSchema(): PageNodeSchema;
    removeChild(child: IPageBaseNode): void;
    changeElementIndex(newIndex: number): void;
}
