import { EventEmitter } from "./event-emitter";
import { PageNodeSchema } from "./models/element-schema.model";
import { IPageElementNode, PageNode } from "./models/page-node.model";
import { PageOptions } from "./models/page-options.model";
import { IPage, IPageLibrary } from "./models/page.model";
import { PageCustomNode } from "./nodes/page-custom-node";
export declare class Page extends EventEmitter implements IPage {
    container: HTMLElement;
    title: string;
    private schema;
    private options;
    rootDocumentRef: Document;
    private styleSheet;
    private rootElement;
    private libraries;
    private iframe;
    get documentRef(): Document;
    get windowRef(): Window;
    constructor(container: HTMLElement, title: string, schema: PageNodeSchema, options: PageOptions, rootDocumentRef: Document);
    getRootElement(): IPageElementNode;
    getStyleSheet(): CSSStyleSheet;
    getLinkedLibraries(): IPageLibrary[];
    getSchema(): PageNodeSchema;
    schemaChanged(): void;
    getOptions(): PageOptions;
    buildElements(container: HTMLElement): void;
    customElementFactory(element: PageCustomNode): HTMLElement;
    nodeCreated(node: PageNode): void;
    findElement(predicate: (el: PageNode) => boolean): PageNode | undefined;
    linkLibrary({ name, href, rel, ...rest }: {
        name: string;
        href: string;
        rel: string;
        [prop: string]: string;
    }): Promise<void>;
    logError(node: PageNode, errorMessage: string): void;
    private registerIframe;
    private registerStyleSheet;
    private getStubElement;
}
