import { StyleType } from "../models/style.model";
import { ElementEdges } from "../models/element-edges.model";
import { PageElementNode } from "../nodes/page-element-node";
import { StyleBase } from "./style-base";
export type BorderStyleType = 'solid' | 'dotted';
export interface BorderRadiusEdges {
    topLeft: string;
    topRight: string;
    bottomLeft: string;
    bottomRight: string;
}
export interface IBorderStyle {
    width?: ElementEdges<string> | string;
    styleType?: ElementEdges<BorderStyleType>;
    color?: ElementEdges<string> | string;
    radius?: BorderRadiusEdges | string;
}
export declare class BorderStyle extends StyleBase<IBorderStyle> {
    element: PageElementNode;
    styleType: StyleType;
    selector: string;
    styleSheet: CSSStyleSheet;
    constructor(element: PageElementNode);
    setWidth(width: ElementEdges<string> | string, apply?: boolean): void;
    getWidth(): ElementEdges<string> | string | undefined;
    setStyleType(styleType: ElementEdges<BorderStyleType> | BorderStyleType, apply?: boolean): void;
    getStyleType(): ElementEdges<BorderStyleType> | BorderStyleType | undefined;
    setColor(color: ElementEdges<string> | string, apply?: boolean): void;
    getColor(): ElementEdges<string> | string | undefined;
    setBorderRadius(radius: BorderRadiusEdges | string, apply?: boolean): void;
    getBorderRadius(): BorderRadiusEdges | string | undefined;
    private setInitialValuesOnChange;
}
