import { StyleType } from "../models/style.model";
import { PageElementNode } from "../nodes/page-element-node";
import { StyleRule } from "./style-rule";
export declare abstract class StyleBase<T = Record<string, string>> {
    abstract styleSheet: CSSStyleSheet;
    abstract styleType: StyleType;
    abstract selector: string;
    abstract element: PageElementNode;
    protected rule: StyleRule;
    protected ruleText?: string;
    protected ruleIndex: number;
    setStyleRule(ruleValue: T): void;
    applyStyles(): void;
    protected tryToApplyStyleRule(apply?: boolean): void;
    private applyStyleRule;
    private insertRule;
    private updateRule;
    private deleteRule;
    private hardDeleteRule;
    private updateNodeSchema;
}
